#ifndef IKD_OX_SPRITE_H
#define IKD_OX_SPRITE_H

// 2D`pXvCgNX

#include <d3d9.h>
#include <d3dx9.h>
#include <list>

namespace OX {
	class Sprite {
		static IDirect3DVertexBuffer9 *buf;			// ʒPʃTCY|_obt@
		static std::list<Sprite*> drawObjectList;		// `ΏۃXg
		static IDirect3DVertexDeclaration9 *decl;	// ʒ_錾
		static ID3DXEffect *effect;					// ʃGtFNg

		IDirect3DTexture9 *tex;		// eNX`
		int scW, scH;			// XN[TCY
		int polyW, polyH;		// |STCY
		float pivotX, pivotY;	// s{bgW
		float posX, posY, posZ;	// ʒu
		float rad;				// ]pxiWAj
		float scaleX, scaleY;	// XP[
		float uvLeft, uvTop;	// UVW
		float uvW, uvH;			// UV
		float alpha;			// ߓx
		bool bActivity;			// ANeBu

		// Rs[
		void copy( const Sprite &r );

	public:
		Sprite();
		Sprite( int screenWidth, int screenHeight );
		Sprite( const Sprite &r );
		~Sprite();

		Sprite &operator =( const Sprite &r ) { copy(r); return *this; }

		// ʒ_obt@쐬
		static void begin_first( IDirect3DDevice9* dev );

		// Еt
		static void end_last();

		// |TCYw
		void setSize( int w, int h );

		// XN[TCYw
		void setScreenSize( int w, int h );

		// s{bgw
		void setPivot( float x, float y );
		void getPivot( float *x, float *y );

		// pw
		void setPos( float x, float y );
		void getPos( float *x, float *y );
		void setRotate( float deg );
		float getRotate();
		void setScale( float sx, float sy );
		void getScale( float *sx, float *sy );

		// eNX`ݒ
		void setTexture( IDirect3DTexture9 *tex, bool isResize );

		// UV؂w
		void setUV( float l, float t, float w, float h );
		void getUV_LT( float *l, float *t );
		void getUV_WH( float *w, float *h );

		// ݒ
		void setAlpha( float a );
		float getAlpha();

		// vCIeBݒ
		void setPriority( float z );
		float getPriority();

		// ANeBreBݒ
		void setActivity( bool isActive );
		bool getActivity();

		// `惊Xgɐς
		void draw();

		// `惊XgCɕ`
		static void drawAll( IDirect3DDevice9 *dev );

		// `惊XgNA
		static void Sprite::clearDrawList();

	};
}

#endif
